image: php:8.2

services:
  - mysql:latest

variables:
  MYSQL_ROOT_PASSWORD: secret
  MYSQL_DATABASE: laravel
  MYSQL_USER: laravel
  MYSQL_PASSWORD: secret
  DB_HOST: mysql
  DB_PORT: 3306
  DB_USERNAME: laravel
  DB_PASSWORD: secret
  DB_DATABASE: laravel

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - vendor/
    - node_modules/

stages:
  - setup
  - test
  - deploy

setup:
  stage: setup
  script:
    - apt-get update && apt-get install -y unzip git libpng-dev libjpeg-dev libfreetype6-dev zip
    - docker-php-ext-configure gd --with-freetype --with-jpeg
    - docker-php-ext-install gd pdo pdo_mysql
    - pecl install xdebug && docker-php-ext-enable xdebug
    - curl -sS https://getcomposer.org/installer | php -- --install-dir=/usr/local/bin --filename=composer
    - cp .env.example .env
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress --no-scripts
    - php artisan key:generate
  artifacts:
    paths:
      - vendor/

test:
  stage: test
  script:
    - apt-get update && apt-get install -y libzip-dev
    - docker-php-ext-install pdo_mysql
    - php artisan migrate --env=testing --force
    - ./vendor/bin/phpunit
  dependencies:
    - setup

deploy:
  stage: deploy
  script:
    - echo "Deploying to production server..."
    # Добавьте здесь свои команды развертывания
  only:
    - master
